#!/bin/sh

WORK_DIR=/opt
MACHINE=Aquila-Pro
PID=1002

if [ ! -d /mnt ];then
    mkdir /mnt
fi

for i in 1 2 3 4;
do
  if [ ! -e /dev/sda$i ]; then
     echo "sda$i not exist"
	 if [ ! -e /dev/sda ];then
     	continue
	 else
	 	echo "find /dev/sda. start mount."
		mount -t vfat -o codepage=936,iocharset=utf8 /dev/sda /mnt
	 fi
  else
	mount -t vfat -o codepage=936,iocharset=utf8 /dev/sda$i /mnt
  fi

  if [ $? -ne 0 ]; then
        echo "mount /dev/sda or /dev/sda$i to /mnt failed"
        continue
  else
  		ls -1t /mnt/Aquila-Pro*.tgz
		if [ $? -eq 0 ];then
			UPDATEFILE=`ls -1t /mnt/Aquila-Pro*.tgz | head -n 1`
			if [ -f $UPDATEFILE ];then
				echo "find update file: ${UPDATEFILE}"
				rm -rf /opt/update
				cp -a ${UPDATEFILE} /opt/
				if [ $? -ne 0 ];then
					rm -rf /opt/Aquila-Pro*.tgz
					sync
					umount /mnt
					break
				fi
				sync
				mkdir -p /opt/update
				sync
				SRCFILE="/opt/`basename ${UPDATEFILE}`"
				if [ -f ${SRCFILE} ];then
					tar -xzvf ${SRCFILE} -C /opt/update/
					sync
					rm -rf ${SRCFILE}
					/opt/update/flashforge_init.sh ${MACHINE} ${PID}
					if [ $? -eq 0 ];then
						umount /mnt
						rm -rf /opt/update
						sleep 100000
					fi
					umount /mnt
					rm -rf /opt/update
					break
				fi
			fi
		fi

        if [ -f /mnt/flashforge_init.sh ]; then
             echo "found /mnt/flashforge_init.sh"
             chmod a+x /mnt/flashforge_init.sh
             /mnt/flashforge_init.sh ${MACHINE} ${PID}
			 if [ $? -eq 0 ];then
				umount /mnt
				sleep 100000
			 fi
             umount /mnt
             break
        fi
        umount /mnt
  fi
done

if [ -d /opt/update ];then
	rm -rf /opt/update
fi

echo 137 > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio137/direction
echo 0 > /sys/class/gpio/gpio137/value
echo 0 > /sys/class/gpio/gpio137/value
echo 1 > /sys/class/gpio/gpio137/value
echo 1 > /sys/class/gpio/gpio137/value
echo 137 > /sys/class/gpio/unexport

/opt/PROGRAM/ffstartup-arm -f /opt/PROGRAM/ffstartup.cfg &
