#!/bin/sh
# Author:		和岩波
# Description:	单个固件包升级程序
# Date:			2019-10-28

set -x

WORK_DIR=`dirname $0`

#检测机器的架构,错误马上退出
CHECH_ARCH=`uname -m`
if [ "${CHECH_ARCH}" != "armv5tejl" ];then
    echo "Machine architecture error."
    echo ${CHECH_ARCH}
    exit 1
fi

#检测内核版本，错误马上退出
CHECH_KERNEL=`uname -r`
if [ "${CHECH_KERNEL}" != "3.10.65" ];then
    echo "Kernel version error."
    echo ${CHECH_KERNEL}
    exit 1
fi

#upgrade kernel
DTB_FILE_NAME=${WORK_DIR}/sunxi.dtb
UIMAGE_FILE_PREFIX=zImage-Aquila-pro
ls -1t ${WORK_DIR}/${UIMAGE_FILE_PREFIX}*
if [ $? -eq 0 ]; then
	SRC_UIMAGE=`ls -1t ${WORK_DIR}/${UIMAGE_FILE_PREFIX}* | head -n 1`
	echo "source uImage file: ${SRC_UIMAGE}"
	if [ -f $SRC_UIMAGE ]; then
		echo "update uImage"
		mkdir -p /tmp/test
		sync
		mount -t vfat -o codepage=936,iocharset=utf8 /dev/mmcblk0p1  /tmp/test
		cp -vf $SRC_UIMAGE /tmp/test/zImage
		sync
		if [ -f $DTB_FILE_NAME ];then
			cp -vf $DTB_FILE_NAME /tmp/test
			sync
		fi
		sync
		umount /tmp/test
		rm -rf /tmp/test
	fi
fi

exit 0
